﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Public Class Person
    Implements INotifyPropertyChanged

    Public Sub New()
    End Sub

    Private _Name As String = String.Empty
    Public Property Name() As String
        Get
            Return _Name
        End Get
        Set(ByVal value As String)
            _Name = value
            SamName = $"{Name}.{Age}"
            RaisePropertyChanged()
        End Set
    End Property

    Private _Age As Integer = 0
    Public Property Age() As Integer
        Get
            Return _Age
        End Get
        Set(ByVal value As Integer)
            _Age = value
            SamName = $"{Name}.{Age}"
            RaisePropertyChanged()
        End Set
    End Property

    Public Property IsDeleted As Boolean = False


    Private _samName As String = String.Empty
    Public Property SamName() As String
        Get
            Return _samName
        End Get
        Set(ByVal value As String)
            _samName = value
            RaisePropertyChanged()

        End Set
    End Property



#Region "PropertyChanged"
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub
#End Region
End Class